﻿function TDAutoVendor(maxValue, priceSource, maxQuality, maxIlvl, sellCrapBlue, debug)
    maxValue = maxValue or 5000000;
    priceSource = priceSource or 'DBGlobalSaleAvg';
    maxQuality = maxQuality or 3;
    sellCrapBlue = sellCrapBlue or true;
    debug = debug or false;
    maxIlvl = maxIlvl or 630;
    -- 0 = junk, 1 = normal, 2 = green, 3 = blue, 4 = purple, 5 = legendary

    local prof1, prof2 = GetProfessions();
    local hasEnchanting = prof1 == 8 or prof2 == 8;

    if debug then
        print('max value: ' .. maxValue .. ', source: ' .. priceSource .. ', maxQ: ' .. maxQuality .. ', sell blue: '
            .. tostring(sellCrapBlue) .. ', maxIlvl: ' .. maxIlvl .. ', has ench: ' .. tostring(hasEnchanting));
    end

    local WEAPON, ARMOR = TSMAPI.Util:Select({1, 2}, GetAuctionItemClasses());

    for bag, slot, itemString in TSMAPI.Inventory:BagIterator(nil, true) do
        local _, itemLink, quality, ilvl, _, iType, _, _, _, _, vendorPrice = TSMAPI.Item:GetInfo(itemString);
        local disenchantable = TSMAPI.Item:IsDisenchantable(itemString);
        local soulbound = TSMAPI.Item:IsSoulbound(itemString);
        local customSalePrice = TSMAPI:GetCustomPriceValue(priceSource, itemString);

        if itemString and vendorPrice > 0 and
            (quality == 0 or -- junk
                (disenchantable and ilvl <= maxIlvl and (iType == ARMOR or iType == WEAPON) and quality <= maxQuality) and
                (
                    (customSalePrice and customSalePrice <= maxValue) or
                    (
                        not hasEnchanting and sellCrapBlue and soulbound and quality == 3 and
                        ilvl >= 570 and ilvl <= 630 and (not customSalePrice or customSalePrice <= maxValue)
                    )
                )
            )
        then
            local venPrice = '';
            local cusPrice = '';
            if vendorPrice > 0 then
                venPrice = ' vendor: ' .. TSMAPI:MoneyToString(vendorPrice, 'OPT_ICON');
            end
            if customSalePrice and customSalePrice > 0 then
                cusPrice = ' AH: ' .. TSMAPI:MoneyToString(customSalePrice, 'OPT_ICON');
            end

            if debug then
                print("Would sell " .. itemLink .. venPrice .. cusPrice);
            elseif MerchantFrame:IsShown() then
                print("Selling " .. itemLink .. venPrice .. cusPrice);
                ShowContainerSellCursor(bag, slot);
                UseContainerItem(bag, slot);
                ResetCursor();
            else
                print('Merchant frame is not opened!');
            end
        end
    end
end
